#include "recordeditform.h"
#include "ui_recordeditform.h"

RecordEditForm::RecordEditForm(QWidget *parent) :
  QWidget(parent),
  ui(new Ui::RecordEditForm)
{
  ui->setupUi(this);
  //Создание объекта связывания
  mapper = new QDataWidgetMapper(this);
  //Установка режима сохранения изменений в модель
  //ManualSubmit - данные из виджетов сохраняются в модель после явного вызова метода submit()
  //AutoSubmit - изменение созраняется в модель при потере фокуса связанным виджетом
  mapper->setSubmitPolicy(QDataWidgetMapper::ManualSubmit);
}

RecordEditForm::~RecordEditForm()
{
  delete ui;
}

void RecordEditForm::setModel(QAbstractItemModel *model)
{
  //Назначение связываемой модели
  mapper->setModel(model);
  //Назначение связываемых с моделью виджетов
  mapper->addMapping(ui->cbProduct, 1);
  mapper->addMapping(ui->edtCompany, 2);
  //явно указывано свойство виджета, значение которого будет связано с полем модели
  mapper->addMapping(ui->edtDetails, 3, "plainText");
}

void RecordEditForm::on_btnApply_clicked()
{
  //явный вызов сохранения изменений из виджетов в модель (в режиме ManualSubmit)
  mapper->submit();
}

void RecordEditForm::on_btnClose_clicked()
{
  //закрытие формы редактирования (объект формы не удаляется)
  close();
}
